package com.customfit.ctg.view;

/**
 * This represents any of the sub-panels which can be loaded up
 * into the MainFrame.
 * 
 * @author David
 */
public abstract class SubPanel extends javax.swing.JPanel {
    /**
     * Holds the title of the sub-panel, which will be used
     * later in the main frame to update the title bar
     * and/or other elements as needed. 
     */
    protected String title;

    /**
     * Gets the title of the sub-panel.
     * 
     * @return The sub-panel title.
     */
    public String getTitle() {
            return title;
    }

    /** Creates new form SubPanel */
    public SubPanel() {
        initComponents();
    }
    
    /**
     * This is used for forms that require data refreshing.
     */
    public void refresh()
    {
        System.err.println("SubPanel.refresh() was hit, but wasn't implemented (overridden). Override this method and set it to update data.");
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables

}
